diff -r de462f2f1db8 tools/libxc/xc_domain_restore.c
--- a/tools/libxc/xc_domain_restore.c	Mon Aug 27 21:38:11 2012 +0800
+++ b/tools/libxc/xc_domain_restore.c	Mon Aug 27 21:56:53 2012 +0800
@@ -1207,8 +1207,11 @@
 
         if ( pagetype == XEN_DOMCTL_PFINFO_BROKEN )
         {
+            fprintf(stderr, "@target, find broken page, "
+                      "dom=%d, pfn=0x%lx, pagetype=0x%lx\n", dom, pfn, pagetype);
             if ( xc_set_broken_page_p2m(xch, dom, pfn) )
             {
+                fprintf(stderr, "... ERROR WHEN SET P2M FOR BROKEN PAGE\n");
                 ERROR("Set p2m for broken page fail, "
                       "dom=%d, pfn=%lx\n", dom, pfn);
                 goto err_mapped;
diff -r de462f2f1db8 tools/libxc/xc_domain_save.c
--- a/tools/libxc/xc_domain_save.c	Mon Aug 27 21:38:11 2012 +0800
+++ b/tools/libxc/xc_domain_save.c	Mon Aug 27 21:56:53 2012 +0800
@@ -1289,6 +1289,9 @@
                 {
                     pfn_type[j] |= pfn_batch[j];
                     ++run;
+                    fprintf(stderr, "@sender, find broken page, "
+                            "pfn_err[0x%x]=%d, pfn_type[0x%x] =%lx\n",
+                    (int)j, (int)pfn_err[j], (int)j, (unsigned long)pfn_type[j]);
                     continue;
                 }
 
diff -r de462f2f1db8 xen/arch/x86/domctl.c
--- a/xen/arch/x86/domctl.c	Mon Aug 27 21:38:11 2012 +0800
+++ b/xen/arch/x86/domctl.c	Mon Aug 27 21:56:53 2012 +0800
@@ -1566,13 +1566,19 @@
         struct domain *d;
         p2m_type_t pt;
         unsigned long pfn;
+        mfn_t r_mfn;
 
         d = rcu_lock_domain_by_id(domctl->domain);
         if ( d != NULL )
         {
             pfn = domctl->u.set_broken_page_p2m.pfn;
 
-            get_gfn_query(d, pfn, &pt);
+            r_mfn = get_gfn_query(d, pfn, &pt);
+            printk("@XEN_DOMCTL_set_broken_page_p2m, before set p2m, "
+                   "pfn=%lx, pt=%d\n", pfn, (int)pt);
+            if (!mfn_valid(mfn_x(r_mfn)))
+                printk("r_mfn IS INVALID!!!\n");
+
             p2m_change_type(d, pfn, pt, p2m_ram_broken);
             put_gfn(d, pfn);
 
